#include <qimageblitz_includes.h>

#include <smoke.h>
#include <qimageblitz_smoke.h>

namespace __smokeqimageblitz {

static void *cast(void *xptr, Smoke::Index from, Smoke::Index to) {
  switch(from) {
    case 1:   //Blitz
      switch(to) {
        case 1: return (void*)(Blitz*)xptr;
        default: return xptr;
      }
    case 2:   //QBool
      switch(to) {
        case 2: return (void*)(QBool*)xptr;
        default: return xptr;
      }
    case 3:   //QColor
      switch(to) {
        case 3: return (void*)(QColor*)xptr;
        default: return xptr;
      }
    case 5:   //QImage
      switch(to) {
        case 5: return (void*)(QImage*)xptr;
        default: return xptr;
      }
    case 6:   //QIncompatibleFlag
      switch(to) {
        case 6: return (void*)(QIncompatibleFlag*)xptr;
        default: return xptr;
      }
    case 7:   //QRegExp
      switch(to) {
        case 7: return (void*)(QRegExp*)xptr;
        default: return xptr;
      }
    case 8:   //QSize
      switch(to) {
        case 8: return (void*)(QSize*)xptr;
        default: return xptr;
      }
    default: return xptr;
  }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index inheritanceList[] = {
    0,	// 0: (no super class)
};

// These are the xenum functions for manipulating enum pointers
void xenum_QGlobalSpace(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Blitz(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_Blitz(Smoke::Index, void*, Smoke::Stack);
void xcall_QGlobalSpace(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, external, index into inheritanceList, method dispatcher, enum dispatcher, class flags, size
static Smoke::Class classes[] = {
    { 0L, false, 0, 0, 0, 0, 0 },	// 0 (no class)
    { "Blitz", false, 0, xcall_Blitz, xenum_Blitz, Smoke::cf_constructor|Smoke::cf_deepcopy, sizeof(Blitz) },	//1
    { "QBool", true, 0, 0, 0, 0, 0 },	//2
    { "QColor", true, 0, 0, 0, 0, 0 },	//3
    { "QGlobalSpace", false, 0, xcall_QGlobalSpace, xenum_QGlobalSpace, Smoke::cf_namespace, 0 },	//4
    { "QImage", true, 0, 0, 0, 0, 0 },	//5
    { "QIncompatibleFlag", true, 0, 0, 0, 0, 0 },	//6
    { "QRegExp", true, 0, 0, 0, 0, 0 },	//7
    { "QSize", true, 0, 0, 0, 0, 0 },	//8
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type types[] = {
    { 0, 0, 0 },	//0 (no type)
    { "Blitz*", 1, Smoke::t_class|Smoke::tf_ptr },	//1
    { "Blitz::EffectQuality", 1, Smoke::t_enum|Smoke::tf_stack },	//2
    { "Blitz::GradientType", 1, Smoke::t_enum|Smoke::tf_stack },	//3
    { "Blitz::ModulationType", 1, Smoke::t_enum|Smoke::tf_stack },	//4
    { "Blitz::RGBChannel", 1, Smoke::t_enum|Smoke::tf_stack },	//5
    { "Blitz::ScaleFilterType", 1, Smoke::t_enum|Smoke::tf_stack },	//6
    { "QBool", 2, Smoke::t_class|Smoke::tf_stack },	//7
    { "QFlags<QtConcurrent::ReduceOptions::enum_type>", 0, Smoke::t_uint|Smoke::tf_stack },	//8
    { "QImage", 5, Smoke::t_class|Smoke::tf_stack },	//9
    { "QImage&", 5, Smoke::t_class|Smoke::tf_ref },	//10
    { "QImage::InvertMode", 5, Smoke::t_enum|Smoke::tf_stack },	//11
    { "QIncompatibleFlag", 6, Smoke::t_class|Smoke::tf_stack },	//12
    { "QRegExp&", 7, Smoke::t_class|Smoke::tf_ref },	//13
    { "QString", 0, Smoke::t_voidp|Smoke::tf_stack },	//14
    { "QStringList", 0, Smoke::t_voidp|Smoke::tf_stack },	//15
    { "QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//16
    { "Qt::AlignmentFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//17
    { "Qt::AnchorAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//18
    { "Qt::AnchorPoint", 0, Smoke::t_enum|Smoke::tf_stack },	//19
    { "Qt::ApplicationAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//20
    { "Qt::ArrowType", 0, Smoke::t_enum|Smoke::tf_stack },	//21
    { "Qt::AspectRatioMode", 0, Smoke::t_enum|Smoke::tf_stack },	//22
    { "Qt::Axis", 0, Smoke::t_enum|Smoke::tf_stack },	//23
    { "Qt::BGMode", 0, Smoke::t_enum|Smoke::tf_stack },	//24
    { "Qt::BrushStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//25
    { "Qt::CaseSensitivity", 0, Smoke::t_enum|Smoke::tf_stack },	//26
    { "Qt::CheckState", 0, Smoke::t_enum|Smoke::tf_stack },	//27
    { "Qt::ClipOperation", 0, Smoke::t_enum|Smoke::tf_stack },	//28
    { "Qt::ConnectionType", 0, Smoke::t_enum|Smoke::tf_stack },	//29
    { "Qt::ContextMenuPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//30
    { "Qt::CoordinateSystem", 0, Smoke::t_enum|Smoke::tf_stack },	//31
    { "Qt::Corner", 0, Smoke::t_enum|Smoke::tf_stack },	//32
    { "Qt::CursorMoveStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//33
    { "Qt::CursorShape", 0, Smoke::t_enum|Smoke::tf_stack },	//34
    { "Qt::DateFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//35
    { "Qt::DayOfWeek", 0, Smoke::t_enum|Smoke::tf_stack },	//36
    { "Qt::DockWidgetArea", 0, Smoke::t_enum|Smoke::tf_stack },	//37
    { "Qt::DockWidgetAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//38
    { "Qt::DropAction", 0, Smoke::t_enum|Smoke::tf_stack },	//39
    { "Qt::EventPriority", 0, Smoke::t_enum|Smoke::tf_stack },	//40
    { "Qt::FillRule", 0, Smoke::t_enum|Smoke::tf_stack },	//41
    { "Qt::FocusPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//42
    { "Qt::FocusReason", 0, Smoke::t_enum|Smoke::tf_stack },	//43
    { "Qt::GestureFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//44
    { "Qt::GestureState", 0, Smoke::t_enum|Smoke::tf_stack },	//45
    { "Qt::GestureType", 0, Smoke::t_enum|Smoke::tf_stack },	//46
    { "Qt::GlobalColor", 0, Smoke::t_enum|Smoke::tf_stack },	//47
    { "Qt::ImageConversionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//48
    { "Qt::Initialization", 0, Smoke::t_enum|Smoke::tf_stack },	//49
    { "Qt::InputMethodHint", 0, Smoke::t_enum|Smoke::tf_stack },	//50
    { "Qt::InputMethodQuery", 0, Smoke::t_enum|Smoke::tf_stack },	//51
    { "Qt::ItemDataRole", 0, Smoke::t_enum|Smoke::tf_stack },	//52
    { "Qt::ItemFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//53
    { "Qt::ItemSelectionMode", 0, Smoke::t_enum|Smoke::tf_stack },	//54
    { "Qt::Key", 0, Smoke::t_enum|Smoke::tf_stack },	//55
    { "Qt::KeyboardModifier", 0, Smoke::t_enum|Smoke::tf_stack },	//56
    { "Qt::LayoutDirection", 0, Smoke::t_enum|Smoke::tf_stack },	//57
    { "Qt::MaskMode", 0, Smoke::t_enum|Smoke::tf_stack },	//58
    { "Qt::MatchFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//59
    { "Qt::Modifier", 0, Smoke::t_enum|Smoke::tf_stack },	//60
    { "Qt::MouseButton", 0, Smoke::t_enum|Smoke::tf_stack },	//61
    { "Qt::NavigationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//62
    { "Qt::Orientation", 0, Smoke::t_enum|Smoke::tf_stack },	//63
    { "Qt::PenCapStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//64
    { "Qt::PenJoinStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//65
    { "Qt::PenStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//66
    { "Qt::ScrollBarPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//67
    { "Qt::ShortcutContext", 0, Smoke::t_enum|Smoke::tf_stack },	//68
    { "Qt::SizeHint", 0, Smoke::t_enum|Smoke::tf_stack },	//69
    { "Qt::SizeMode", 0, Smoke::t_enum|Smoke::tf_stack },	//70
    { "Qt::SortOrder", 0, Smoke::t_enum|Smoke::tf_stack },	//71
    { "Qt::TextElideMode", 0, Smoke::t_enum|Smoke::tf_stack },	//72
    { "Qt::TextFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//73
    { "Qt::TextFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//74
    { "Qt::TextInteractionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//75
    { "Qt::TileRule", 0, Smoke::t_enum|Smoke::tf_stack },	//76
    { "Qt::TimeSpec", 0, Smoke::t_enum|Smoke::tf_stack },	//77
    { "Qt::ToolBarArea", 0, Smoke::t_enum|Smoke::tf_stack },	//78
    { "Qt::ToolBarAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//79
    { "Qt::ToolButtonStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//80
    { "Qt::TouchPointState", 0, Smoke::t_enum|Smoke::tf_stack },	//81
    { "Qt::TransformationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//82
    { "Qt::UIEffect", 0, Smoke::t_enum|Smoke::tf_stack },	//83
    { "Qt::WidgetAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//84
    { "Qt::WindowFrameSection", 0, Smoke::t_enum|Smoke::tf_stack },	//85
    { "Qt::WindowModality", 0, Smoke::t_enum|Smoke::tf_stack },	//86
    { "Qt::WindowState", 0, Smoke::t_enum|Smoke::tf_stack },	//87
    { "Qt::WindowType", 0, Smoke::t_enum|Smoke::tf_stack },	//88
    { "QtConcurrent::ReduceOption", 0, Smoke::t_enum|Smoke::tf_stack },	//89
    { "QtConcurrent::ReduceOptions::enum_type", 0, Smoke::t_voidp|Smoke::tf_stack },	//90
    { "QtConcurrent::ThreadFunctionResult", 0, Smoke::t_enum|Smoke::tf_stack },	//91
    { "QtMsgType", 4, Smoke::t_enum|Smoke::tf_stack },	//92
    { "QtValidLicenseForActiveQtModule", 4, Smoke::t_enum|Smoke::tf_stack },	//93
    { "QtValidLicenseForCoreModule", 4, Smoke::t_enum|Smoke::tf_stack },	//94
    { "QtValidLicenseForDBusModule", 4, Smoke::t_enum|Smoke::tf_stack },	//95
    { "QtValidLicenseForDeclarativeModule", 4, Smoke::t_enum|Smoke::tf_stack },	//96
    { "QtValidLicenseForGuiModule", 4, Smoke::t_enum|Smoke::tf_stack },	//97
    { "QtValidLicenseForHelpModule", 4, Smoke::t_enum|Smoke::tf_stack },	//98
    { "QtValidLicenseForMultimediaModule", 4, Smoke::t_enum|Smoke::tf_stack },	//99
    { "QtValidLicenseForNetworkModule", 4, Smoke::t_enum|Smoke::tf_stack },	//100
    { "QtValidLicenseForOpenGLModule", 4, Smoke::t_enum|Smoke::tf_stack },	//101
    { "QtValidLicenseForOpenVGModule", 4, Smoke::t_enum|Smoke::tf_stack },	//102
    { "QtValidLicenseForQt3SupportLightModule", 4, Smoke::t_enum|Smoke::tf_stack },	//103
    { "QtValidLicenseForQt3SupportModule", 4, Smoke::t_enum|Smoke::tf_stack },	//104
    { "QtValidLicenseForScriptModule", 4, Smoke::t_enum|Smoke::tf_stack },	//105
    { "QtValidLicenseForScriptToolsModule", 4, Smoke::t_enum|Smoke::tf_stack },	//106
    { "QtValidLicenseForSqlModule", 4, Smoke::t_enum|Smoke::tf_stack },	//107
    { "QtValidLicenseForSvgModule", 4, Smoke::t_enum|Smoke::tf_stack },	//108
    { "QtValidLicenseForTestModule", 4, Smoke::t_enum|Smoke::tf_stack },	//109
    { "QtValidLicenseForXmlModule", 4, Smoke::t_enum|Smoke::tf_stack },	//110
    { "QtValidLicenseForXmlPatternsModule", 4, Smoke::t_enum|Smoke::tf_stack },	//111
    { "__codecvt_result", 4, Smoke::t_enum|Smoke::tf_stack },	//112
    { "bool", 0, Smoke::t_bool|Smoke::tf_stack },	//113
    { "const Blitz&", 1, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//114
    { "const QColor&", 3, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//115
    { "const QRegExp&", 7, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//116
    { "const QSize&", 8, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//117
    { "const QString&", 0, Smoke::t_voidp|Smoke::tf_ref|Smoke::tf_const },	//118
    { "const QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//119
    { "const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//120
    { "float", 0, Smoke::t_float|Smoke::tf_stack },	//121
    { "float*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//122
    { "int", 0, Smoke::t_int|Smoke::tf_stack },	//123
    { "int*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//124
    { "long", 0, Smoke::t_long|Smoke::tf_stack },	//125
    { "std::bidirectional_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//126
    { "std::forward_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//127
    { "std::random_access_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//128
    { "unsigned char", 0, Smoke::t_uchar|Smoke::tf_stack },	//129
    { "unsigned int", 0, Smoke::t_uint|Smoke::tf_stack },	//130
    { "volatile const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//131
};

static Smoke::Index argumentList[] = {
    0,	//0  (void)
    10, 11, 0,	//1  QImage&, QImage::InvertMode
    10, 113, 0,	//4  QImage&, bool
    10, 117, 22, 0,	//7  QImage&, const QSize&, Qt::AspectRatioMode
    10, 123, 123, 22, 0,	//11  QImage&, int, int, Qt::AspectRatioMode
    10, 117, 121, 6, 22, 0,	//16  QImage&, const QSize&, float, Blitz::ScaleFilterType, Qt::AspectRatioMode
    10, 123, 123, 121, 6, 22, 0,	//22  QImage&, int, int, float, Blitz::ScaleFilterType, Qt::AspectRatioMode
    10, 123, 122, 0,	//29  QImage&, int, float*
    10, 123, 124, 123, 0,	//33  QImage&, int, int*, int
    10, 123, 0,	//38  QImage&, int
    10, 121, 121, 0,	//41  QImage&, float, float
    10, 0,	//45  QImage&
    10, 121, 2, 0,	//47  QImage&, float, Blitz::EffectQuality
    10, 121, 121, 2, 0,	//51  QImage&, float, float, Blitz::EffectQuality
    10, 113, 123, 0,	//56  QImage&, bool, int
    10, 121, 0,	//60  QImage&, float
    10, 121, 5, 0,	//63  QImage&, float, Blitz::RGBChannel
    10, 121, 115, 0,	//67  QImage&, float, const QColor&
    10, 115, 115, 0,	//71  QImage&, const QColor&, const QColor&
    10, 129, 5, 130, 130, 0,	//75  QImage&, unsigned char, Blitz::RGBChannel, unsigned int, unsigned int
    10, 121, 121, 130, 0,	//81  QImage&, float, float, unsigned int
    117, 115, 115, 3, 0,	//86  const QSize&, const QColor&, const QColor&, Blitz::GradientType
    117, 129, 129, 3, 0,	//91  const QSize&, unsigned char, unsigned char, Blitz::GradientType
    117, 115, 115, 3, 123, 123, 0,	//96  const QSize&, const QColor&, const QColor&, Blitz::GradientType, int, int
    117, 129, 129, 3, 123, 123, 0,	//103  const QSize&, unsigned char, unsigned char, Blitz::GradientType, int, int
    10, 10, 113, 4, 123, 5, 0,	//110  QImage&, QImage&, bool, Blitz::ModulationType, int, Blitz::RGBChannel
    114, 0,	//117  const Blitz&
    10, 117, 0,	//119  QImage&, const QSize&
    10, 123, 123, 0,	//122  QImage&, int, int
    10, 117, 121, 0,	//126  QImage&, const QSize&, float
    10, 117, 121, 6, 0,	//130  QImage&, const QSize&, float, Blitz::ScaleFilterType
    10, 123, 123, 121, 0,	//135  QImage&, int, int, float
    10, 123, 123, 121, 6, 0,	//140  QImage&, int, int, float, Blitz::ScaleFilterType
    10, 123, 124, 0,	//146  QImage&, int, int*
    10, 129, 0,	//150  QImage&, unsigned char
    10, 129, 5, 0,	//153  QImage&, unsigned char, Blitz::RGBChannel
    10, 129, 5, 130, 0,	//157  QImage&, unsigned char, Blitz::RGBChannel, unsigned int
    117, 115, 115, 3, 123, 0,	//162  const QSize&, const QColor&, const QColor&, Blitz::GradientType, int
    117, 129, 129, 3, 123, 0,	//168  const QSize&, unsigned char, unsigned char, Blitz::GradientType, int
};

// Raw list of all methods, using munged names
static const char *methodNames[] = {
    "",	//0
    "All",	//1
    "Alpha",	//2
    "BesselFilter",	//3
    "BlackmanFilter",	//4
    "Blitz",	//5
    "Blitz#",	//6
    "Blue",	//7
    "BoxFilter",	//8
    "Brightness",	//9
    "CatromFilter",	//10
    "Contrast",	//11
    "CrossDiagonalGradient",	//12
    "CubicFilter",	//13
    "DiagonalGradient",	//14
    "EllipticGradient",	//15
    "GaussianFilter",	//16
    "Grayscale",	//17
    "Green",	//18
    "HammingFilter",	//19
    "HanningFilter",	//20
    "HermiteFilter",	//21
    "High",	//22
    "HorizontalGradient",	//23
    "HueShift",	//24
    "Intensity",	//25
    "LanczosFilter",	//26
    "LicensedActiveQt",	//27
    "LicensedCore",	//28
    "LicensedDBus",	//29
    "LicensedDeclarative",	//30
    "LicensedGui",	//31
    "LicensedHelp",	//32
    "LicensedMultimedia",	//33
    "LicensedNetwork",	//34
    "LicensedOpenGL",	//35
    "LicensedOpenVG",	//36
    "LicensedQt3Support",	//37
    "LicensedQt3SupportLight",	//38
    "LicensedScript",	//39
    "LicensedScriptTools",	//40
    "LicensedSql",	//41
    "LicensedSvg",	//42
    "LicensedTest",	//43
    "LicensedXml",	//44
    "LicensedXmlPatterns",	//45
    "Low",	//46
    "MitchellFilter",	//47
    "PipeCrossGradient",	//48
    "PointFilter",	//49
    "PyramidGradient",	//50
    "QtCriticalMsg",	//51
    "QtDebugMsg",	//52
    "QtFatalMsg",	//53
    "QtSystemMsg",	//54
    "QtWarningMsg",	//55
    "QuadraticFilter",	//56
    "RectangleGradient",	//57
    "Red",	//58
    "Saturation",	//59
    "SincFilter",	//60
    "TriangleFilter",	//61
    "UndefinedFilter",	//62
    "VerticalGradient",	//63
    "_ISalnum",	//64
    "_ISalpha",	//65
    "_ISblank",	//66
    "_IScntrl",	//67
    "_ISdigit",	//68
    "_ISgraph",	//69
    "_ISlower",	//70
    "_ISprint",	//71
    "_ISpunct",	//72
    "_ISspace",	//73
    "_ISupper",	//74
    "_ISxdigit",	//75
    "__codecvt_error",	//76
    "__codecvt_noconv",	//77
    "__codecvt_ok",	//78
    "__codecvt_partial",	//79
    "antialias",	//80
    "antialias#",	//81
    "blur",	//82
    "blur#",	//83
    "blur#$",	//84
    "channelIntensity",	//85
    "channelIntensity#$$",	//86
    "charcoal",	//87
    "charcoal#",	//88
    "contrast",	//89
    "contrast#$",	//90
    "contrast#$$",	//91
    "convolve",	//92
    "convolve#$$",	//93
    "convolveEdge",	//94
    "convolveEdge#",	//95
    "convolveEdge#$",	//96
    "convolveEdge#$$",	//97
    "convolveInteger",	//98
    "convolveInteger#$$",	//99
    "convolveInteger#$$$",	//100
    "desaturate",	//101
    "desaturate#",	//102
    "desaturate#$",	//103
    "despeckle",	//104
    "despeckle#",	//105
    "edge",	//106
    "edge#",	//107
    "emboss",	//108
    "emboss#",	//109
    "emboss#$",	//110
    "emboss#$$",	//111
    "emboss#$$$",	//112
    "equalize",	//113
    "equalize#",	//114
    "fade",	//115
    "fade#$#",	//116
    "flatten",	//117
    "flatten###",	//118
    "gaussianBlur",	//119
    "gaussianBlur#",	//120
    "gaussianBlur#$",	//121
    "gaussianBlur#$$",	//122
    "gaussianSharpen",	//123
    "gaussianSharpen#",	//124
    "gaussianSharpen#$",	//125
    "gaussianSharpen#$$",	//126
    "gaussianSharpen#$$$",	//127
    "gradient",	//128
    "gradient###$",	//129
    "grayGradient",	//130
    "grayGradient#$$$",	//131
    "grayUnbalancedGradient",	//132
    "grayUnbalancedGradient#$$$",	//133
    "grayUnbalancedGradient#$$$$",	//134
    "grayUnbalancedGradient#$$$$$",	//135
    "grayscale",	//136
    "grayscale#",	//137
    "grayscale#$",	//138
    "implode",	//139
    "implode#",	//140
    "implode#$",	//141
    "intensity",	//142
    "intensity#$",	//143
    "invert",	//144
    "invert#",	//145
    "invert#$",	//146
    "modulate",	//147
    "modulate##$$$$",	//148
    "normalize",	//149
    "normalize#",	//150
    "oilPaint",	//151
    "oilPaint#",	//152
    "oilPaint#$",	//153
    "oilPaint#$$",	//154
    "sharpen",	//155
    "sharpen#",	//156
    "sharpen#$",	//157
    "smoothScale",	//158
    "smoothScale##",	//159
    "smoothScale##$",	//160
    "smoothScale#$$",	//161
    "smoothScale#$$$",	//162
    "smoothScaleFilter",	//163
    "smoothScaleFilter##",	//164
    "smoothScaleFilter##$",	//165
    "smoothScaleFilter##$$",	//166
    "smoothScaleFilter##$$$",	//167
    "smoothScaleFilter#$$",	//168
    "smoothScaleFilter#$$$",	//169
    "smoothScaleFilter#$$$$",	//170
    "smoothScaleFilter#$$$$$",	//171
    "swirl",	//172
    "swirl#",	//173
    "swirl#$",	//174
    "threshold",	//175
    "threshold#",	//176
    "threshold#$",	//177
    "threshold#$$",	//178
    "threshold#$$$",	//179
    "threshold#$$$$",	//180
    "unbalancedGradient",	//181
    "unbalancedGradient###$",	//182
    "unbalancedGradient###$$",	//183
    "unbalancedGradient###$$$",	//184
    "wave",	//185
    "wave#",	//186
    "wave#$",	//187
    "wave#$$",	//188
    "wave#$$$",	//189
    "~Blitz",	//190
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method methods[] = {
    { 0, 0, 0, 0, 0, 0, 0 },	// (no method)
    {1, 144, 1, 2, Smoke::mf_static, 113, 1},	//1 Blitz::invert(QImage&, QImage::InvertMode)
    {1, 136, 4, 2, Smoke::mf_static, 113, 2},	//2 Blitz::grayscale(QImage&, bool)
    {1, 158, 7, 3, Smoke::mf_static, 9, 3},	//3 Blitz::smoothScale(QImage&, const QSize&, Qt::AspectRatioMode)
    {1, 158, 11, 4, Smoke::mf_static, 9, 4},	//4 Blitz::smoothScale(QImage&, int, int, Qt::AspectRatioMode)
    {1, 163, 16, 5, Smoke::mf_static, 9, 5},	//5 Blitz::smoothScaleFilter(QImage&, const QSize&, float, Blitz::ScaleFilterType, Qt::AspectRatioMode)
    {1, 163, 22, 6, Smoke::mf_static, 9, 6},	//6 Blitz::smoothScaleFilter(QImage&, int, int, float, Blitz::ScaleFilterType, Qt::AspectRatioMode)
    {1, 92, 29, 3, Smoke::mf_static, 9, 7},	//7 Blitz::convolve(QImage&, int, float*)
    {1, 98, 33, 4, Smoke::mf_static, 9, 8},	//8 Blitz::convolveInteger(QImage&, int, int*, int)
    {1, 82, 38, 2, Smoke::mf_static, 9, 9},	//9 Blitz::blur(QImage&, int)
    {1, 119, 41, 3, Smoke::mf_static, 9, 10},	//10 Blitz::gaussianBlur(QImage&, float, float)
    {1, 106, 45, 1, Smoke::mf_static, 9, 11},	//11 Blitz::edge(QImage&)
    {1, 94, 47, 3, Smoke::mf_static, 9, 12},	//12 Blitz::convolveEdge(QImage&, float, Blitz::EffectQuality)
    {1, 123, 51, 4, Smoke::mf_static, 9, 13},	//13 Blitz::gaussianSharpen(QImage&, float, float, Blitz::EffectQuality)
    {1, 155, 38, 2, Smoke::mf_static, 9, 14},	//14 Blitz::sharpen(QImage&, int)
    {1, 108, 51, 4, Smoke::mf_static, 9, 15},	//15 Blitz::emboss(QImage&, float, float, Blitz::EffectQuality)
    {1, 80, 45, 1, Smoke::mf_static, 9, 16},	//16 Blitz::antialias(QImage&)
    {1, 104, 45, 1, Smoke::mf_static, 10, 17},	//17 Blitz::despeckle(QImage&)
    {1, 89, 56, 3, Smoke::mf_static, 10, 18},	//18 Blitz::contrast(QImage&, bool, int)
    {1, 113, 45, 1, Smoke::mf_static, 113, 19},	//19 Blitz::equalize(QImage&)
    {1, 149, 45, 1, Smoke::mf_static, 113, 20},	//20 Blitz::normalize(QImage&)
    {1, 142, 60, 2, Smoke::mf_static, 10, 21},	//21 Blitz::intensity(QImage&, float)
    {1, 85, 63, 3, Smoke::mf_static, 10, 22},	//22 Blitz::channelIntensity(QImage&, float, Blitz::RGBChannel)
    {1, 101, 60, 2, Smoke::mf_static, 10, 23},	//23 Blitz::desaturate(QImage&, float)
    {1, 115, 67, 3, Smoke::mf_static, 10, 24},	//24 Blitz::fade(QImage&, float, const QColor&)
    {1, 117, 71, 3, Smoke::mf_static, 10, 25},	//25 Blitz::flatten(QImage&, const QColor&, const QColor&)
    {1, 175, 75, 5, Smoke::mf_static, 9, 26},	//26 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel, unsigned int, unsigned int)
    {1, 172, 60, 2, Smoke::mf_static, 9, 27},	//27 Blitz::swirl(QImage&, float)
    {1, 139, 60, 2, Smoke::mf_static, 9, 28},	//28 Blitz::implode(QImage&, float)
    {1, 185, 81, 4, Smoke::mf_static, 9, 29},	//29 Blitz::wave(QImage&, float, float, unsigned int)
    {1, 151, 47, 3, Smoke::mf_static, 9, 30},	//30 Blitz::oilPaint(QImage&, float, Blitz::EffectQuality)
    {1, 87, 45, 1, Smoke::mf_static, 9, 31},	//31 Blitz::charcoal(QImage&)
    {1, 128, 86, 4, Smoke::mf_static, 9, 32},	//32 Blitz::gradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType)
    {1, 130, 91, 4, Smoke::mf_static, 9, 33},	//33 Blitz::grayGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType)
    {1, 181, 96, 6, Smoke::mf_static, 9, 34},	//34 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType, int, int)
    {1, 132, 103, 6, Smoke::mf_static, 9, 35},	//35 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType, int, int)
    {1, 147, 110, 6, Smoke::mf_static, 10, 36},	//36 Blitz::modulate(QImage&, QImage&, bool, Blitz::ModulationType, int, Blitz::RGBChannel)
    {1, 5, 0, 0, Smoke::mf_ctor, 1, 37},	//37 Blitz::Blitz()
    {1, 5, 117, 1, Smoke::mf_ctor|Smoke::mf_copyctor, 1, 38},	//38 Blitz::Blitz(const Blitz&)
    {1, 144, 45, 1, Smoke::mf_static, 113, 39},	//39 Blitz::invert(QImage&)
    {1, 136, 45, 1, Smoke::mf_static, 113, 40},	//40 Blitz::grayscale(QImage&)
    {1, 158, 119, 2, Smoke::mf_static, 9, 41},	//41 Blitz::smoothScale(QImage&, const QSize&)
    {1, 158, 122, 3, Smoke::mf_static, 9, 42},	//42 Blitz::smoothScale(QImage&, int, int)
    {1, 163, 119, 2, Smoke::mf_static, 9, 43},	//43 Blitz::smoothScaleFilter(QImage&, const QSize&)
    {1, 163, 126, 3, Smoke::mf_static, 9, 44},	//44 Blitz::smoothScaleFilter(QImage&, const QSize&, float)
    {1, 163, 130, 4, Smoke::mf_static, 9, 45},	//45 Blitz::smoothScaleFilter(QImage&, const QSize&, float, Blitz::ScaleFilterType)
    {1, 163, 122, 3, Smoke::mf_static, 9, 46},	//46 Blitz::smoothScaleFilter(QImage&, int, int)
    {1, 163, 135, 4, Smoke::mf_static, 9, 47},	//47 Blitz::smoothScaleFilter(QImage&, int, int, float)
    {1, 163, 140, 5, Smoke::mf_static, 9, 48},	//48 Blitz::smoothScaleFilter(QImage&, int, int, float, Blitz::ScaleFilterType)
    {1, 98, 146, 3, Smoke::mf_static, 9, 49},	//49 Blitz::convolveInteger(QImage&, int, int*)
    {1, 82, 45, 1, Smoke::mf_static, 9, 50},	//50 Blitz::blur(QImage&)
    {1, 119, 45, 1, Smoke::mf_static, 9, 51},	//51 Blitz::gaussianBlur(QImage&)
    {1, 119, 60, 2, Smoke::mf_static, 9, 52},	//52 Blitz::gaussianBlur(QImage&, float)
    {1, 94, 45, 1, Smoke::mf_static, 9, 53},	//53 Blitz::convolveEdge(QImage&)
    {1, 94, 60, 2, Smoke::mf_static, 9, 54},	//54 Blitz::convolveEdge(QImage&, float)
    {1, 123, 45, 1, Smoke::mf_static, 9, 55},	//55 Blitz::gaussianSharpen(QImage&)
    {1, 123, 60, 2, Smoke::mf_static, 9, 56},	//56 Blitz::gaussianSharpen(QImage&, float)
    {1, 123, 41, 3, Smoke::mf_static, 9, 57},	//57 Blitz::gaussianSharpen(QImage&, float, float)
    {1, 155, 45, 1, Smoke::mf_static, 9, 58},	//58 Blitz::sharpen(QImage&)
    {1, 108, 45, 1, Smoke::mf_static, 9, 59},	//59 Blitz::emboss(QImage&)
    {1, 108, 60, 2, Smoke::mf_static, 9, 60},	//60 Blitz::emboss(QImage&, float)
    {1, 108, 41, 3, Smoke::mf_static, 9, 61},	//61 Blitz::emboss(QImage&, float, float)
    {1, 89, 4, 2, Smoke::mf_static, 10, 62},	//62 Blitz::contrast(QImage&, bool)
    {1, 101, 45, 1, Smoke::mf_static, 10, 63},	//63 Blitz::desaturate(QImage&)
    {1, 175, 45, 1, Smoke::mf_static, 9, 64},	//64 Blitz::threshold(QImage&)
    {1, 175, 150, 2, Smoke::mf_static, 9, 65},	//65 Blitz::threshold(QImage&, unsigned char)
    {1, 175, 153, 3, Smoke::mf_static, 9, 66},	//66 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel)
    {1, 175, 157, 4, Smoke::mf_static, 9, 67},	//67 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel, unsigned int)
    {1, 172, 45, 1, Smoke::mf_static, 9, 68},	//68 Blitz::swirl(QImage&)
    {1, 139, 45, 1, Smoke::mf_static, 9, 69},	//69 Blitz::implode(QImage&)
    {1, 185, 45, 1, Smoke::mf_static, 9, 70},	//70 Blitz::wave(QImage&)
    {1, 185, 60, 2, Smoke::mf_static, 9, 71},	//71 Blitz::wave(QImage&, float)
    {1, 185, 41, 3, Smoke::mf_static, 9, 72},	//72 Blitz::wave(QImage&, float, float)
    {1, 151, 45, 1, Smoke::mf_static, 9, 73},	//73 Blitz::oilPaint(QImage&)
    {1, 151, 60, 2, Smoke::mf_static, 9, 74},	//74 Blitz::oilPaint(QImage&, float)
    {1, 181, 86, 4, Smoke::mf_static, 9, 75},	//75 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType)
    {1, 181, 162, 5, Smoke::mf_static, 9, 76},	//76 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType, int)
    {1, 132, 91, 4, Smoke::mf_static, 9, 77},	//77 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType)
    {1, 132, 168, 5, Smoke::mf_static, 9, 78},	//78 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType, int)
    {1, 63, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 79},	//79 Blitz::VerticalGradient (enum)
    {1, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 80},	//80 Blitz::HorizontalGradient (enum)
    {1, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 81},	//81 Blitz::DiagonalGradient (enum)
    {1, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 82},	//82 Blitz::CrossDiagonalGradient (enum)
    {1, 50, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 83},	//83 Blitz::PyramidGradient (enum)
    {1, 57, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 84},	//84 Blitz::RectangleGradient (enum)
    {1, 48, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 85},	//85 Blitz::PipeCrossGradient (enum)
    {1, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 86},	//86 Blitz::EllipticGradient (enum)
    {1, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 87},	//87 Blitz::Grayscale (enum)
    {1, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 88},	//88 Blitz::Brightness (enum)
    {1, 58, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 89},	//89 Blitz::Red (enum)
    {1, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 90},	//90 Blitz::Green (enum)
    {1, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 91},	//91 Blitz::Blue (enum)
    {1, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 92},	//92 Blitz::Alpha (enum)
    {1, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 93},	//93 Blitz::All (enum)
    {1, 46, 0, 0, Smoke::mf_static|Smoke::mf_enum, 2, 94},	//94 Blitz::Low (enum)
    {1, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 2, 95},	//95 Blitz::High (enum)
    {1, 62, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 96},	//96 Blitz::UndefinedFilter (enum)
    {1, 49, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 97},	//97 Blitz::PointFilter (enum)
    {1, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 98},	//98 Blitz::BoxFilter (enum)
    {1, 61, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 99},	//99 Blitz::TriangleFilter (enum)
    {1, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 100},	//100 Blitz::HermiteFilter (enum)
    {1, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 101},	//101 Blitz::HanningFilter (enum)
    {1, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 102},	//102 Blitz::HammingFilter (enum)
    {1, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 103},	//103 Blitz::BlackmanFilter (enum)
    {1, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 104},	//104 Blitz::GaussianFilter (enum)
    {1, 56, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 105},	//105 Blitz::QuadraticFilter (enum)
    {1, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 106},	//106 Blitz::CubicFilter (enum)
    {1, 10, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 107},	//107 Blitz::CatromFilter (enum)
    {1, 47, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 108},	//108 Blitz::MitchellFilter (enum)
    {1, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 109},	//109 Blitz::LanczosFilter (enum)
    {1, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 110},	//110 Blitz::BesselFilter (enum)
    {1, 60, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 111},	//111 Blitz::SincFilter (enum)
    {1, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 112},	//112 Blitz::Intensity (enum)
    {1, 59, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 113},	//113 Blitz::Saturation (enum)
    {1, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 114},	//114 Blitz::HueShift (enum)
    {1, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 115},	//115 Blitz::Contrast (enum)
    {1, 190, 0, 0, Smoke::mf_dtor, 0, 116 },	//116 Blitz::~Blitz()
    {4, 74, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 1},	//117 QGlobalSpace::_ISupper (enum)
    {4, 70, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 2},	//118 QGlobalSpace::_ISlower (enum)
    {4, 65, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 3},	//119 QGlobalSpace::_ISalpha (enum)
    {4, 68, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 4},	//120 QGlobalSpace::_ISdigit (enum)
    {4, 75, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 5},	//121 QGlobalSpace::_ISxdigit (enum)
    {4, 73, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 6},	//122 QGlobalSpace::_ISspace (enum)
    {4, 71, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 7},	//123 QGlobalSpace::_ISprint (enum)
    {4, 69, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 8},	//124 QGlobalSpace::_ISgraph (enum)
    {4, 66, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 9},	//125 QGlobalSpace::_ISblank (enum)
    {4, 67, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 10},	//126 QGlobalSpace::_IScntrl (enum)
    {4, 72, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 11},	//127 QGlobalSpace::_ISpunct (enum)
    {4, 64, 0, 0, Smoke::mf_static|Smoke::mf_enum, 125, 12},	//128 QGlobalSpace::_ISalnum (enum)
    {4, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 13},	//129 QGlobalSpace::LicensedGui (enum)
    {4, 44, 0, 0, Smoke::mf_static|Smoke::mf_enum, 110, 14},	//130 QGlobalSpace::LicensedXml (enum)
    {4, 38, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 15},	//131 QGlobalSpace::LicensedQt3SupportLight (enum)
    {4, 39, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 16},	//132 QGlobalSpace::LicensedScript (enum)
    {4, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 102, 17},	//133 QGlobalSpace::LicensedOpenVG (enum)
    {4, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 18},	//134 QGlobalSpace::LicensedDBus (enum)
    {4, 43, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 19},	//135 QGlobalSpace::LicensedTest (enum)
    {4, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 20},	//136 QGlobalSpace::LicensedActiveQt (enum)
    {4, 40, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 21},	//137 QGlobalSpace::LicensedScriptTools (enum)
    {4, 42, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 22},	//138 QGlobalSpace::LicensedSvg (enum)
    {4, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 23},	//139 QGlobalSpace::LicensedDeclarative (enum)
    {4, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 24},	//140 QGlobalSpace::LicensedSql (enum)
    {4, 35, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 25},	//141 QGlobalSpace::LicensedOpenGL (enum)
    {4, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 94, 26},	//142 QGlobalSpace::LicensedCore (enum)
    {4, 52, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 27},	//143 QGlobalSpace::QtDebugMsg (enum)
    {4, 55, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 28},	//144 QGlobalSpace::QtWarningMsg (enum)
    {4, 51, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 29},	//145 QGlobalSpace::QtCriticalMsg (enum)
    {4, 53, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 30},	//146 QGlobalSpace::QtFatalMsg (enum)
    {4, 54, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 31},	//147 QGlobalSpace::QtSystemMsg (enum)
    {4, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 98, 32},	//148 QGlobalSpace::LicensedHelp (enum)
    {4, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 99, 33},	//149 QGlobalSpace::LicensedMultimedia (enum)
    {4, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 34},	//150 QGlobalSpace::LicensedQt3Support (enum)
    {4, 45, 0, 0, Smoke::mf_static|Smoke::mf_enum, 111, 35},	//151 QGlobalSpace::LicensedXmlPatterns (enum)
    {4, 34, 0, 0, Smoke::mf_static|Smoke::mf_enum, 100, 36},	//152 QGlobalSpace::LicensedNetwork (enum)
    {4, 78, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 37},	//153 QGlobalSpace::__codecvt_ok (enum)
    {4, 79, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 38},	//154 QGlobalSpace::__codecvt_partial (enum)
    {4, 76, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 39},	//155 QGlobalSpace::__codecvt_error (enum)
    {4, 77, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 40},	//156 QGlobalSpace::__codecvt_noconv (enum)
};

static Smoke::Index ambiguousMethodList[] = {
    0,
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap methodMaps[] = {
    {0, 0, 0},	//0 (no method)
    {1, 1, 93},	// Blitz::All
    {1, 2, 92},	// Blitz::Alpha
    {1, 3, 110},	// Blitz::BesselFilter
    {1, 4, 103},	// Blitz::BlackmanFilter
    {1, 5, 37},	// Blitz::Blitz
    {1, 6, 38},	// Blitz::Blitz#
    {1, 7, 91},	// Blitz::Blue
    {1, 8, 98},	// Blitz::BoxFilter
    {1, 9, 88},	// Blitz::Brightness
    {1, 10, 107},	// Blitz::CatromFilter
    {1, 11, 115},	// Blitz::Contrast
    {1, 12, 82},	// Blitz::CrossDiagonalGradient
    {1, 13, 106},	// Blitz::CubicFilter
    {1, 14, 81},	// Blitz::DiagonalGradient
    {1, 15, 86},	// Blitz::EllipticGradient
    {1, 16, 104},	// Blitz::GaussianFilter
    {1, 17, 87},	// Blitz::Grayscale
    {1, 18, 90},	// Blitz::Green
    {1, 19, 102},	// Blitz::HammingFilter
    {1, 20, 101},	// Blitz::HanningFilter
    {1, 21, 100},	// Blitz::HermiteFilter
    {1, 22, 95},	// Blitz::High
    {1, 23, 80},	// Blitz::HorizontalGradient
    {1, 24, 114},	// Blitz::HueShift
    {1, 25, 112},	// Blitz::Intensity
    {1, 26, 109},	// Blitz::LanczosFilter
    {1, 46, 94},	// Blitz::Low
    {1, 47, 108},	// Blitz::MitchellFilter
    {1, 48, 85},	// Blitz::PipeCrossGradient
    {1, 49, 97},	// Blitz::PointFilter
    {1, 50, 83},	// Blitz::PyramidGradient
    {1, 56, 105},	// Blitz::QuadraticFilter
    {1, 57, 84},	// Blitz::RectangleGradient
    {1, 58, 89},	// Blitz::Red
    {1, 59, 113},	// Blitz::Saturation
    {1, 60, 111},	// Blitz::SincFilter
    {1, 61, 99},	// Blitz::TriangleFilter
    {1, 62, 96},	// Blitz::UndefinedFilter
    {1, 63, 79},	// Blitz::VerticalGradient
    {1, 81, 16},	// Blitz::antialias#
    {1, 83, 50},	// Blitz::blur#
    {1, 84, 9},	// Blitz::blur#$
    {1, 86, 22},	// Blitz::channelIntensity#$$
    {1, 88, 31},	// Blitz::charcoal#
    {1, 90, 62},	// Blitz::contrast#$
    {1, 91, 18},	// Blitz::contrast#$$
    {1, 93, 7},	// Blitz::convolve#$$
    {1, 95, 53},	// Blitz::convolveEdge#
    {1, 96, 54},	// Blitz::convolveEdge#$
    {1, 97, 12},	// Blitz::convolveEdge#$$
    {1, 99, 49},	// Blitz::convolveInteger#$$
    {1, 100, 8},	// Blitz::convolveInteger#$$$
    {1, 102, 63},	// Blitz::desaturate#
    {1, 103, 23},	// Blitz::desaturate#$
    {1, 105, 17},	// Blitz::despeckle#
    {1, 107, 11},	// Blitz::edge#
    {1, 109, 59},	// Blitz::emboss#
    {1, 110, 60},	// Blitz::emboss#$
    {1, 111, 61},	// Blitz::emboss#$$
    {1, 112, 15},	// Blitz::emboss#$$$
    {1, 114, 19},	// Blitz::equalize#
    {1, 116, 24},	// Blitz::fade#$#
    {1, 118, 25},	// Blitz::flatten###
    {1, 120, 51},	// Blitz::gaussianBlur#
    {1, 121, 52},	// Blitz::gaussianBlur#$
    {1, 122, 10},	// Blitz::gaussianBlur#$$
    {1, 124, 55},	// Blitz::gaussianSharpen#
    {1, 125, 56},	// Blitz::gaussianSharpen#$
    {1, 126, 57},	// Blitz::gaussianSharpen#$$
    {1, 127, 13},	// Blitz::gaussianSharpen#$$$
    {1, 129, 32},	// Blitz::gradient###$
    {1, 131, 33},	// Blitz::grayGradient#$$$
    {1, 133, 77},	// Blitz::grayUnbalancedGradient#$$$
    {1, 134, 78},	// Blitz::grayUnbalancedGradient#$$$$
    {1, 135, 35},	// Blitz::grayUnbalancedGradient#$$$$$
    {1, 137, 40},	// Blitz::grayscale#
    {1, 138, 2},	// Blitz::grayscale#$
    {1, 140, 69},	// Blitz::implode#
    {1, 141, 28},	// Blitz::implode#$
    {1, 143, 21},	// Blitz::intensity#$
    {1, 145, 39},	// Blitz::invert#
    {1, 146, 1},	// Blitz::invert#$
    {1, 148, 36},	// Blitz::modulate##$$$$
    {1, 150, 20},	// Blitz::normalize#
    {1, 152, 73},	// Blitz::oilPaint#
    {1, 153, 74},	// Blitz::oilPaint#$
    {1, 154, 30},	// Blitz::oilPaint#$$
    {1, 156, 58},	// Blitz::sharpen#
    {1, 157, 14},	// Blitz::sharpen#$
    {1, 159, 41},	// Blitz::smoothScale##
    {1, 160, 3},	// Blitz::smoothScale##$
    {1, 161, 42},	// Blitz::smoothScale#$$
    {1, 162, 4},	// Blitz::smoothScale#$$$
    {1, 164, 43},	// Blitz::smoothScaleFilter##
    {1, 165, 44},	// Blitz::smoothScaleFilter##$
    {1, 166, 45},	// Blitz::smoothScaleFilter##$$
    {1, 167, 5},	// Blitz::smoothScaleFilter##$$$
    {1, 168, 46},	// Blitz::smoothScaleFilter#$$
    {1, 169, 47},	// Blitz::smoothScaleFilter#$$$
    {1, 170, 48},	// Blitz::smoothScaleFilter#$$$$
    {1, 171, 6},	// Blitz::smoothScaleFilter#$$$$$
    {1, 173, 68},	// Blitz::swirl#
    {1, 174, 27},	// Blitz::swirl#$
    {1, 176, 64},	// Blitz::threshold#
    {1, 177, 65},	// Blitz::threshold#$
    {1, 178, 66},	// Blitz::threshold#$$
    {1, 179, 67},	// Blitz::threshold#$$$
    {1, 180, 26},	// Blitz::threshold#$$$$
    {1, 182, 75},	// Blitz::unbalancedGradient###$
    {1, 183, 76},	// Blitz::unbalancedGradient###$$
    {1, 184, 34},	// Blitz::unbalancedGradient###$$$
    {1, 186, 70},	// Blitz::wave#
    {1, 187, 71},	// Blitz::wave#$
    {1, 188, 72},	// Blitz::wave#$$
    {1, 189, 29},	// Blitz::wave#$$$
    {1, 190, 116},	// Blitz::~Blitz
    {4, 27, 136},	// QGlobalSpace::LicensedActiveQt
    {4, 28, 142},	// QGlobalSpace::LicensedCore
    {4, 29, 134},	// QGlobalSpace::LicensedDBus
    {4, 30, 139},	// QGlobalSpace::LicensedDeclarative
    {4, 31, 129},	// QGlobalSpace::LicensedGui
    {4, 32, 148},	// QGlobalSpace::LicensedHelp
    {4, 33, 149},	// QGlobalSpace::LicensedMultimedia
    {4, 34, 152},	// QGlobalSpace::LicensedNetwork
    {4, 35, 141},	// QGlobalSpace::LicensedOpenGL
    {4, 36, 133},	// QGlobalSpace::LicensedOpenVG
    {4, 37, 150},	// QGlobalSpace::LicensedQt3Support
    {4, 38, 131},	// QGlobalSpace::LicensedQt3SupportLight
    {4, 39, 132},	// QGlobalSpace::LicensedScript
    {4, 40, 137},	// QGlobalSpace::LicensedScriptTools
    {4, 41, 140},	// QGlobalSpace::LicensedSql
    {4, 42, 138},	// QGlobalSpace::LicensedSvg
    {4, 43, 135},	// QGlobalSpace::LicensedTest
    {4, 44, 130},	// QGlobalSpace::LicensedXml
    {4, 45, 151},	// QGlobalSpace::LicensedXmlPatterns
    {4, 51, 145},	// QGlobalSpace::QtCriticalMsg
    {4, 52, 143},	// QGlobalSpace::QtDebugMsg
    {4, 53, 146},	// QGlobalSpace::QtFatalMsg
    {4, 54, 147},	// QGlobalSpace::QtSystemMsg
    {4, 55, 144},	// QGlobalSpace::QtWarningMsg
    {4, 64, 128},	// QGlobalSpace::_ISalnum
    {4, 65, 119},	// QGlobalSpace::_ISalpha
    {4, 66, 125},	// QGlobalSpace::_ISblank
    {4, 67, 126},	// QGlobalSpace::_IScntrl
    {4, 68, 120},	// QGlobalSpace::_ISdigit
    {4, 69, 124},	// QGlobalSpace::_ISgraph
    {4, 70, 118},	// QGlobalSpace::_ISlower
    {4, 71, 123},	// QGlobalSpace::_ISprint
    {4, 72, 127},	// QGlobalSpace::_ISpunct
    {4, 73, 122},	// QGlobalSpace::_ISspace
    {4, 74, 117},	// QGlobalSpace::_ISupper
    {4, 75, 121},	// QGlobalSpace::_ISxdigit
    {4, 76, 155},	// QGlobalSpace::__codecvt_error
    {4, 77, 156},	// QGlobalSpace::__codecvt_noconv
    {4, 78, 153},	// QGlobalSpace::__codecvt_ok
    {4, 79, 154},	// QGlobalSpace::__codecvt_partial
};

}

extern "C" {

static bool initialized = false;
Smoke *qimageblitz_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qimageblitz_Smoke() {
    if (initialized) return;
    qimageblitz_Smoke = new Smoke(
        "qimageblitz",
        __smokeqimageblitz::classes, 8,
        __smokeqimageblitz::methods, 157,
        __smokeqimageblitz::methodMaps, 157,
        __smokeqimageblitz::methodNames, 190,
        __smokeqimageblitz::types, 131,
        __smokeqimageblitz::inheritanceList,
        __smokeqimageblitz::argumentList,
        __smokeqimageblitz::ambiguousMethodList,
        __smokeqimageblitz::cast );
    initialized = true;
}

void delete_qimageblitz_Smoke() { delete qimageblitz_Smoke; }

}
